typedef enum {
    NEGATIVO,
    POSITIVO
} sinal_t;

typedef struct {
    sinal_t sinal;
    unsigned int numerador;
    unsigned int denominador;
} racional_t;

typedef union {
    unsigned int natural;
    int inteiro;
    racional_t racional;
} num_t;

#include <stdio.h>
int main(void)
{
    num_t num1, num2, num3, num4;
    printf("sizeof (unsigned int) = %lu\n"
            "sizeof (int) = %lu\n"
            "sizeof (double) = %lu\n"
            "sizeof (sinal_t) = %lu\n"
            "sizeof (racional_t) = %lu\n"
            "sizeof (num_t) = %lu\n",
            sizeof(unsigned int), sizeof(int),
            sizeof(double), sizeof(sinal_t),
            sizeof(racional_t), sizeof(num_t));
    num1.natural = 1;
    num2.inteiro = 1;
    num4.racional.sinal = POSITIVO;
    num4.racional.numerador = 1;
    num4.racional.denominador = 1;
    printf("sizeof (num1) = %lu\n"
           "sizeof (num2) = %lu\n"
           "sizeof (num3) = %lu\n"
           "sizeof (num4) = %lu\n",
           sizeof(num1), sizeof(num2),
           sizeof(num3), sizeof(num4));
    return 0;
}
